program GetSize;

 // GetSize 1.3.12 by A.Ruzanov
 // 11.09.2008

uses
  Windows,
  Messages,
  KOL,
  wininet;

const
  hlp = 'GetSize v 1.3' + #13#13 + 'Usage: GetSize.exe http://lexi.ucoz.ru/getsize.zip';
  hr  = #13#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151#151;

var
  hSession, hConnect, hRequest: hInternet;
  BufferLen, BufferIndex, HeadersBufferLen, HeadersIndex, Start, TimeOut, dwErr,
  UrlBufLen, State, StLen, MbStyle, OpenType, HttpPort, HttpFlags: cardinal;
  Ret: integer;
  Buffer: array [0..255] of char;
  HeadersBuffer: array [0..4095] of char;
  UrlBuf: array [0..INTERNET_MAX_URL_LENGTH] of char;
  LangFile, LangSize, LangHeaders, LangError, LangResponseTime, LangUnknown,
  FileURL, Sz, UA, Tm, Dm, Proxy, DownloadManager,
  Referer, FileUrlLow, FHost, FPath, FileUrlCorr, Method: string;
  ShowHeaders, ProxySettingsAsIE, DmExists, Offline: boolean;
  GSini: pIniFile;
  ci: INTERNET_CONNECTED_INFO;

  function UrlUnescapeA(pszUrl, pszUnescaped: PAnsiChar; pcchUnescaped: LPDWORD;
    dwFlags: DWORD): HRESULT; stdcall; external 'shlwapi.dll' Name 'UrlUnescapeA';

  // InternetCanonicalizeUrl has problems with utf-8
  function UrlUnescape(Url: string): string;
  var
    buf: array [0..INTERNET_MAX_URL_LENGTH] of char;
    sz:  integer;
  begin
    sz := SizeOf(buf);
    UrlUnescapeA(PChar(Url), buf, @sz, $02000000);
    Result := buf;
  end;

  function ExpandEnvVars(const Str: string): string;
  var
    Sz: integer;
    Buffer: PChar;
  begin
    Sz := ExpandEnvironmentStrings(PChar(Str), nil, 0);
    GetMem(Buffer, Sz);
    ExpandEnvironmentStrings(PChar(Str), Buffer, Sz);
    Result := Buffer;
    FreeMem(Buffer);
    if (Result <> '') and (Pos(':\', Result) = 0) then
      Result := GetStartDir + Result;
  end;

  procedure CreateProc(const CommndLine: string; ShowCmd: integer);
  var
    pi: TProcessInformation;
    si: TStartupInfo;
    CmdLn, StartDir, P: PChar;
    Buf: array [0..MAX_PATH] of char;
  begin
    if CommndLine = '' then
      Exit;
    CmdLn := PChar(CommndLine);
    P := StrRScan(CmdLn, '\');
    if P <> nil then
      StartDir := StrLCopy(Buf, CmdLn, P - CmdLn)
    else
      StartDir := nil;

    ZeroMemory(@si, sizeof(si));
    si.cb := SizeOf(si);
    si.dwFlags := STARTF_USESHOWWINDOW;
    si.wShowWindow := ShowCmd;
    if not CreateProcess(nil, CmdLn, nil, nil, False, 0, nil, StartDir, si, pi) then
      Exit;
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
  end;


  function Ext2Ths(I: extended): string;
  var
    S: string;
  begin
    S := Extended2Str(I);
    Result := '';
    while S <> '' do
    begin
      if Result <> '' then
        Result := #32 + Result;
      Result := CopyTail(S, 3) + Result;
      S := Copy(S, 1, Length(S) - 3);
    end;
    if Copy(Result, 1, 2) = '-' + #32 then
      Result := '-' + CopyEnd(Result, 3);
  end;

  function FmtString(size: int64): string;
  const
    k = 1024;
    m = k * k;
    g = m * k;
  begin
    if size = -1 then
      Result := LangUnknown
    else if size < k then
      Result := Int2Str(size) + ' byte'
    else if size < m then
      Result := Extended2Str(Round(100 * size / k) / 100) + ' KB' + ' (' + Ext2Ths(size) + ' byte)'
    else if size < g then
      Result := Extended2Str(Round(100 * size / m) / 100) + ' MB' + ' (' + Ext2Ths(size) + ' byte)'
    else
      Result := Extended2Str(Round(100 * size / g) / 100) + ' GB' + ' (' + Ext2Ths(size) + ' byte)';
  end;

  function GetWinInetError(ErrorCode: Cardinal): string;
  var
    Len: Integer;
    Buffer: PChar;
  begin
    Len := FormatMessage(
      FORMAT_MESSAGE_FROM_HMODULE or FORMAT_MESSAGE_FROM_SYSTEM or
      FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_IGNORE_INSERTS or  FORMAT_MESSAGE_ARGUMENT_ARRAY,
      Pointer(GetModuleHandle('wininet.dll')), ErrorCode, 0, @Buffer, SizeOf(Buffer), nil);
    try
      while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);
      SetString(Result, Buffer, Len);
    finally
      LocalFree(HLOCAL(Buffer));
    end;
  end;

  function InetErr: string;
  var
    Buf: array [0..1023] of char;
    Err, BufLen, LastErr: Cardinal;
    DescLastErr: string;
  begin
    Result := LangError;
    LastErr := GetLastError;
    if LastErr = ERROR_INTERNET_EXTENDED_ERROR then
      begin
        BufLen := SizeOf(Buf);
        if InternetGetLastResponseInfo(Err, Buf, BufLen) then
          DescLastErr := Trim(Buf);
      end
    else
      DescLastErr := GetWinInetError(LastErr);

    if DescLastErr <> '' then
      Result := Result + ' - ' + DescLastErr;
  end;

  function CorrectCrLf(const S: string): string;
  var
    I: integer;
  begin
    Result := S;
    for I := Length(S) downto 2 do
      if (S[I] = #10) and (S[I - 1] = #13) then
        Delete(Result, I, 1);
    Result := Trim(Result);
  end;

  function SplitPath(var Host: string): string;
  var
    P, Len: integer;
  begin
    Result := '';
    P := Pos('://', Host);
    if P > 0 then
      Delete(Host, 1, P + 2);
    P := Pos('/', Host);
    if P > 0 then
    begin
      Len := Length(Host) - P + 1;
      Result := Copy(Host, P, Len);
      Delete(Host, P, Len);
    end;
  end;

  function CorrectURL(const S: string): string;
  var
    UrlLow: string;
    poz: integer;
  begin
    Result := S;
    UrlLow := LowerCase(Result);
    if (Pos('javascript:', UrlLow) <> 1) and (Pos('mailto:', UrlLow) <> 1) and
      (Pos('opera:', UrlLow) <> 1) and (Pos('about:', UrlLow) <> 1) and
      (Pos('file:', UrlLow) <> 1) then
    begin
      if Pos('_', Result) = 1 then
        Result := CopyEnd(Result, 2);
      poz := Pos('://', Result);
      if (poz > 3) and (Pos('http', UrlLow) <> 1) and (Pos('ftp://', UrlLow) <> 1) then
      begin
        if UrlLow[1] = 'h' then
          Result := 'http' + CopyEnd(Result, poz);
        if Pos('ftp.', UrlLow) = 1 then
          Result := 'ftp://' + Result
        else if UrlLow[1] = 'f' then
          Result := 'ftp' + CopyEnd(Result, poz);
      end
      else if poz = 0 then
        Result := 'http://' + Result;
    end;
  end;


begin
  if ParamCount = 0 then
  begin
    MessageBox(0, PChar(hlp), PChar('About'), 262208);
    Exit;
  end;

  DmExists := False;
  Offline  := False;
  MbStyle  := MB_OK or MB_ICONASTERISK or MB_SETFOREGROUND;

  // Ini read
  GSini := OpenIniFile(ReplaceExt(ParamStr(0), '.ini'));
  GSini.Mode := ifmRead;
  GSini.Section := 'Main';
  UA := GSini.ValueString('UserAgent',
    'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)');
  TimeOut := 1000 * GSini.ValueInteger('TimeOut', 10);
  ShowHeaders := GSini.ValueBoolean('ShowHeaders', True);
  if GSini.ValueBoolean('AlwaysOnTop', True) then
    MbStyle := MbStyle or MB_TOPMOST;
  DownloadManager := GSini.ValueString('DownloadManager', '');
  Proxy := GSini.ValueString('Proxy', '');
  ProxySettingsAsIE := GSini.ValueBoolean('ProxySettingsAsIE', True);
  // WinInet already adds header 'Content-Length: 0' to HEAD request
  Method := GSini.ValueString('Method', 'GET');

  GSini.Section := 'Language';
  LangFile  := GSini.ValueString('File', 'File') + ': ';
  LangSize  := GSini.ValueString('Size', 'Size') + ': ';
  LangHeaders := GSini.ValueString('Headers', 'Headers') + ':' + hr;
  LangError := GSini.ValueString('Error', 'Error');
  LangResponseTime := GSini.ValueString('ResponseTime', 'Response Time') + ': ';
  LangUnknown := GSini.ValueString('Unknown', 'Unknown');

  if DownloadManager <> '' then
    DownloadManager := ExpandEnvVars(DownloadManager);
  if FileExists(DownloadManager) then
  begin
    Dm := #13#13 + GSini.ValueString('DownloadFileWith', 'Download file with') +
      ' ' + ExtractFileNameWOext(DownloadManager) + ' ?' + #13;
    MbStyle := MbStyle or MB_OKCANCEL;
    DmExists := True;
  end;
  GSini.Free;

  // Set variables
  Sz := LangError;
  BufferLen := SizeOf(Buffer);
  HeadersBufferLen := SizeOf(HeadersBuffer);
  UrlBufLen := SizeOf(UrlBuf);
  FileURL := CorrectURL(Trim(ParamStr(1)));
  if (ParamCount > 1) and (HiWord(GetKeyState(VK_CONTROL)) = 0) then
    Referer := Trim(ParamStr(2))
  else
    Referer := '';

  FileUrlCorr := UrlUnescape(FileURL);
  FileUrlLow := LowerCase(FileURL);
  FHost := FileURL;
  FPath := SplitPath(FHost);
  BufferIndex := 0;
  HeadersIndex := 0;
  State := 0;
  StLen := SizeOf(State);
  HttpPort := INTERNET_DEFAULT_HTTP_PORT;
  HttpFlags := INTERNET_FLAG_RELOAD or INTERNET_FLAG_KEEP_CONNECTION;

  // Start
  Start := GetTickCount;
  if Pos('file://', FileUrlLow) = 1 then
  begin
    StrReplace(FileUrlCorr, 'file://localhost/', '');
    StrReplace(FileUrlCorr, 'file:///', '');
    while Pos('/', FileUrlCorr) <> 0 do
      StrReplace(FileUrlCorr, '/', '\');
    Sz := FmtString(FileSize(FileUrlCorr));
  end
  else if (Pos('http', FileUrlLow) = 1) or (Pos('ftp://', FileUrlLow) = 1) then
  begin
    // Online mode. INTERNET_OPTION_IGNORE_OFFLINE - useless.
    if InternetQueryOption(nil, INTERNET_OPTION_CONNECTED_STATE, @State, StLen) then
      if (State and INTERNET_STATE_DISCONNECTED_BY_USER) <> 0 then
      begin
        Offline := True;
        ci.dwConnectedState := INTERNET_STATE_CONNECTED;
        InternetSetOption(nil, INTERNET_OPTION_CONNECTED_STATE, @ci, SizeOf(ci));
      end;
    // Initialize WinInet
    if Proxy <> '' then
      OpenType := INTERNET_OPEN_TYPE_PROXY
    else
    if ProxySettingsAsIE then
      OpenType := INTERNET_OPEN_TYPE_PRECONFIG
    else
      OpenType := INTERNET_OPEN_TYPE_DIRECT;
    hSession := InternetOpen(PChar(UA), OpenType, PChar(Proxy), nil, 0);

    if Assigned(hSession) then
      try
        InternetSetOption(hSession, INTERNET_OPTION_CONNECT_TIMEOUT,
          @TimeOut, sizeof(TimeOut));
        InternetSetOption(hSession, INTERNET_OPTION_RECEIVE_TIMEOUT,
          @TimeOut, sizeof(TimeOut));
        InternetSetOption(hSession, INTERNET_OPTION_SEND_TIMEOUT,
          @TimeOut, sizeof(TimeOut));

        if Pos('ftp://', FileUrlLow) = 1 then
        begin
          // ftp
          hConnect := InternetConnect(hSession, PChar(FHost), INTERNET_DEFAULT_FTP_PORT, nil, nil, INTERNET_SERVICE_FTP, 0, 0);
          if not Assigned(hConnect) then Sz := InetErr else
            try
              // FtpGetFileSize not supported files large then 4Gb
              FtpCommand(hConnect, False, FTP_TRANSFER_TYPE_ASCII, PChar('TYPE I'), 0, nil);
              if FtpCommand(hConnect, False, FTP_TRANSFER_TYPE_ASCII, PChar('SIZE ' + UrlUnescape(FPath)), 0, nil) then
                begin
                  InternetGetLastResponseInfo(dwErr, Buffer, BufferLen);
                  Sz := FmtString(int64(Str2Int64(CopyEnd(Buffer, Pos(' ', Buffer) + 1))));
                end
              else
                Sz := InetErr;
              FtpCommand(hConnect, False, FTP_TRANSFER_TYPE_ASCII, PChar('QUIT'), 0, nil);
            finally
              InternetCloseHandle(hConnect);
            end;
        end
        else
        begin
          // http & https
          if Pos('https', FileUrlLow) = 1 then
          begin
            HttpPort  := INTERNET_DEFAULT_HTTPS_PORT;
            HttpFlags := HttpFlags or INTERNET_FLAG_SECURE or
              INTERNET_FLAG_IGNORE_CERT_CN_INVALID or INTERNET_FLAG_IGNORE_CERT_DATE_INVALID;
          end;

          hConnect := InternetConnect(hSession, PChar(FHost), HttpPort, nil, nil, INTERNET_SERVICE_HTTP, 0, 0);
          if not Assigned(hConnect) then Sz := InetErr else
            try
              hRequest := HttpOpenRequest(hConnect, PChar(Method), PChar(FPath), nil, PChar(Referer), nil, HttpFlags, 0);
              if Assigned(hRequest) then
                try
                  if HttpSendRequest(hRequest, nil, 0, nil, 0) then
                    begin
                      if HttpQueryInfo(hRequest, HTTP_QUERY_CONTENT_LENGTH, @Buffer, BufferLen, BufferIndex) then
                        Sz := FmtString(int64(Str2Int64(Buffer)))
                      else
                        Sz := LangUnknown;

                      if ShowHeaders and HttpQueryInfo(hRequest, HTTP_QUERY_RAW_HEADERS_CRLF, @HeadersBuffer, HeadersBufferLen, HeadersIndex) then
                        Sz := Sz + #13#13 + LangHeaders + #13 + CorrectCrLf(HeadersBuffer) + hr;
                      if InternetQueryOption(hRequest, INTERNET_OPTION_URL, @UrlBuf, UrlBufLen) then
                        FileUrlCorr := UrlUnescape(UrlBuf);
                    end
                    else
                      Sz := InetErr;
                finally
                  InternetCloseHandle(hRequest);
                end;
            finally
              InternetCloseHandle(hConnect);
            end;
        end;

      finally
        InternetCloseHandle(hSession);
      end;
  end;

  Tm := Extended2Str(Round((GetTickCount - Start) / 100) / 10) + ' sec';
  if Offline then
  begin
    ci.dwConnectedState := INTERNET_STATE_DISCONNECTED_BY_USER;
    ci.dwFlags := ISO_FORCE_DISCONNECTED;
    InternetSetOption(nil, INTERNET_OPTION_CONNECTED_STATE, @ci, SizeOf(ci));
  end;
  if DmExists and (Pos(LangError, Sz) = 1) then
    MbStyle := MbStyle or MB_DEFBUTTON2;
  Ret := MessageBox(0, PChar(LangFile + FileUrlCorr + #13#13 + LangResponseTime + Tm +
    #13#13 + LangSize + Sz + Dm), PChar('GetSize'), MbStyle);
  if DmExists and (Ret = ID_OK) then
    CreateProc(DownloadManager + ' ' + FileURL + ' ' + Referer, SW_SHOW);
end.
